unit RepeatButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, extctrls;

type
  TRepeatButton = class(TSpeedButton)
  private
    FOnRepeat: TNotifyEvent;
    function GetRepeatInterval: integer;
    procedure SetRepeatInterval(const Value: integer);
    procedure SetStartInterval(const Value: integer);
    function GetStartInterval: integer;
    { Private declarations }
  protected
   procedure doRepeat(Sender: TObject);
   procedure doStart(Sender: TObject);
  public
   tRepeat: TTimer;
   tStart:  TTimer;
   constructor Create(AOwner: TComponent);override;
   destructor Destroy; override;
   procedure MouseDown(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
   procedure MouseUp(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
  published
   property RepeatInterval: integer read GetRepeatInterval write SetRepeatInterval;
   property StartInterval: integer read GetStartInterval write SetStartInterval;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TRepeatButton]);
end;

{ TRepeatButton }

constructor TRepeatButton.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 tRepeat:=TTimer.Create(Self);
 tRepeat.Enabled:=false;
 tRepeat.Interval:=50;
 tRepeat.OnTimer:=doRepeat;
 tStart:=TTimer.Create(Self);
 tStart.Enabled:=false;
 tStart.Interval:=100;
 tStart.OnTimer:=doStart;
end;

destructor TRepeatButton.Destroy;
begin
 tRepeat.free;
 inherited Destroy;
end;

procedure TRepeatButton.doRepeat(Sender: TObject);
begin
 if assigned(OnClick) then OnClick(Self);
end;

procedure TRepeatButton.doStart(Sender: TObject);
begin
 tStart.Enabled:=false;
 tRepeat.Enabled:=true;
end;

function TRepeatButton.GetRepeatInterval: integer;
begin
 result:=tRepeat.Interval;
end;

function TRepeatButton.GetStartInterval: integer;
begin
 Result:=tStart.Interval;
end;

procedure TRepeatButton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 inherited MouseDown(Button, Shift, X, Y);
 tStart.Enabled:=true;
end;

procedure TRepeatButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 tRepeat.Enabled:=false;
 tStart.Enabled:=false;
 inherited MouseUp(Button, Shift, X, Y);
end;

procedure TRepeatButton.SetRepeatInterval(const Value: integer);
begin
 tRepeat.Interval:=Value;
end;

procedure TRepeatButton.SetStartInterval(const Value: integer);
begin
 tStart.Interval:=Value;
end;

end.
